<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="A simple event-driven library for parsing WebAssembly binary files (or streams)."><meta name="keywords" content="rust, rustlang, rust-lang, wasmparser"><title>wasmparser - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="../crates.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc mod crate"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../wasmparser/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../wasmparser/index.html"><div class="logo-container"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Crate wasmparser</a></h2><div class="sidebar-elems"><div class="block"><ul><li class="version">Version 0.57.0</li><li><a id="all-types" href="all.html">All Items</a></li></ul></div><section><div class="block"><ul><li><a href="#structs">Structs</a></li><li><a href="#enums">Enums</a></li><li><a href="#traits">Traits</a></li><li><a href="#functions">Functions</a></li><li><a href="#types">Type Definitions</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../wasmparser/index.html"><img class="rust-logo" src="../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Crate <a class="mod" href="#">wasmparser</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/wasmparser/lib.rs.html#16-131">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>A simple event-driven library for parsing WebAssembly binary files
(or streams).</p>
<p>The parser library reports events as they happend and only stores
parsing information for a brief period of time, making it very fast
and memory-efficient. The event-driven model, however, has some drawbacks.
If you need random access to the entire WebAssembly data-structure,
this is not the right library for you. You could however, build such
a data-structure using this library.</p>
</div></details><h2 id="structs" class="small-section-header"><a href="#structs">Structs</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BinaryReader.html" title="wasmparser::BinaryReader struct">BinaryReader</a></div><div class="item-right docblock-short"><p>A binary reader of the WebAssembly structures and types.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BinaryReaderError.html" title="wasmparser::BinaryReaderError struct">BinaryReaderError</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.BrTable.html" title="wasmparser::BrTable struct">BrTable</a></div><div class="item-right docblock-short"><p>A br_table entries representation.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.CodeSectionReader.html" title="wasmparser::CodeSectionReader struct">CodeSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Data.html" title="wasmparser::Data struct">Data</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.DataSectionReader.html" title="wasmparser::DataSectionReader struct">DataSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Element.html" title="wasmparser::Element struct">Element</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ElementItems.html" title="wasmparser::ElementItems struct">ElementItems</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ElementItemsReader.html" title="wasmparser::ElementItemsReader struct">ElementItemsReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ElementSectionReader.html" title="wasmparser::ElementSectionReader struct">ElementSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Export.html" title="wasmparser::Export struct">Export</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ExportSectionReader.html" title="wasmparser::ExportSectionReader struct">ExportSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FuncType.html" title="wasmparser::FuncType struct">FuncType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FunctionBody.html" title="wasmparser::FunctionBody struct">FunctionBody</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.FunctionSectionReader.html" title="wasmparser::FunctionSectionReader struct">FunctionSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Global.html" title="wasmparser::Global struct">Global</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.GlobalSectionReader.html" title="wasmparser::GlobalSectionReader struct">GlobalSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.GlobalType.html" title="wasmparser::GlobalType struct">GlobalType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Ieee32.html" title="wasmparser::Ieee32 struct">Ieee32</a></div><div class="item-right docblock-short"><p>An IEEE binary32 immediate floating point value, represented as a u32
containing the bitpattern.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Ieee64.html" title="wasmparser::Ieee64 struct">Ieee64</a></div><div class="item-right docblock-short"><p>An IEEE binary64 immediate floating point value, represented as a u64
containing the bitpattern.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Import.html" title="wasmparser::Import struct">Import</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ImportSectionReader.html" title="wasmparser::ImportSectionReader struct">ImportSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.InitExpr.html" title="wasmparser::InitExpr struct">InitExpr</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.LinkingSectionReader.html" title="wasmparser::LinkingSectionReader struct">LinkingSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.LocalName.html" title="wasmparser::LocalName struct">LocalName</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.LocalsReader.html" title="wasmparser::LocalsReader struct">LocalsReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.MemoryImmediate.html" title="wasmparser::MemoryImmediate struct">MemoryImmediate</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.MemorySectionReader.html" title="wasmparser::MemorySectionReader struct">MemorySectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.MemoryType.html" title="wasmparser::MemoryType struct">MemoryType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ModuleReader.html" title="wasmparser::ModuleReader struct">ModuleReader</a></div><div class="item-right docblock-short"><p>Reads top-level WebAssembly file structure: header and sections.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.NameSectionReader.html" title="wasmparser::NameSectionReader struct">NameSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Naming.html" title="wasmparser::Naming struct">Naming</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.NamingReader.html" title="wasmparser::NamingReader struct">NamingReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.OperatorValidatorConfig.html" title="wasmparser::OperatorValidatorConfig struct">OperatorValidatorConfig</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.OperatorsReader.html" title="wasmparser::OperatorsReader struct">OperatorsReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Parser.html" title="wasmparser::Parser struct">Parser</a></div><div class="item-right docblock-short"><p>The <code>Parser</code> type. A simple event-driven parser of WebAssembly binary
format. The <code>read(&amp;mut self)</code> is used to iterate through WebAssembly records.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ProducersField.html" title="wasmparser::ProducersField struct">ProducersField</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ProducersFieldValue.html" title="wasmparser::ProducersFieldValue struct">ProducersFieldValue</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ProducersFieldValuesReader.html" title="wasmparser::ProducersFieldValuesReader struct">ProducersFieldValuesReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ProducersSectionReader.html" title="wasmparser::ProducersSectionReader struct">ProducersSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Range.html" title="wasmparser::Range struct">Range</a></div><div class="item-right docblock-short"><p>Bytecode range in the WebAssembly module.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Reloc.html" title="wasmparser::Reloc struct">Reloc</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RelocEntry.html" title="wasmparser::RelocEntry struct">RelocEntry</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.RelocSectionReader.html" title="wasmparser::RelocSectionReader struct">RelocSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ResizableLimits.html" title="wasmparser::ResizableLimits struct">ResizableLimits</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.Section.html" title="wasmparser::Section struct">Section</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.SectionIterator.html" title="wasmparser::SectionIterator struct">SectionIterator</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.SectionIteratorLimited.html" title="wasmparser::SectionIteratorLimited struct">SectionIteratorLimited</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.TableSectionReader.html" title="wasmparser::TableSectionReader struct">TableSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.TableType.html" title="wasmparser::TableType struct">TableType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.TypeSectionReader.html" title="wasmparser::TypeSectionReader struct">TypeSectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.V128.html" title="wasmparser::V128 struct">V128</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ValidatingOperatorParser.html" title="wasmparser::ValidatingOperatorParser struct">ValidatingOperatorParser</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ValidatingParser.html" title="wasmparser::ValidatingParser struct">ValidatingParser</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="struct" href="struct.ValidatingParserConfig.html" title="wasmparser::ValidatingParserConfig struct">ValidatingParserConfig</a></div><div class="item-right docblock-short"></div></div></div><h2 id="enums" class="small-section-header"><a href="#enums">Enums</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.CustomSectionContent.html" title="wasmparser::CustomSectionContent enum">CustomSectionContent</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.CustomSectionKind.html" title="wasmparser::CustomSectionKind enum">CustomSectionKind</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.DataKind.html" title="wasmparser::DataKind enum">DataKind</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ElemSectionEntryTable.html" title="wasmparser::ElemSectionEntryTable enum">ElemSectionEntryTable</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ElementItem.html" title="wasmparser::ElementItem enum">ElementItem</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ElementKind.html" title="wasmparser::ElementKind enum">ElementKind</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ExternalKind.html" title="wasmparser::ExternalKind enum">ExternalKind</a></div><div class="item-right docblock-short"><p>External types as defined <a href="https://webassembly.github.io/spec/core/syntax/types.html#external-types">here</a>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ImportSectionEntryType.html" title="wasmparser::ImportSectionEntryType enum">ImportSectionEntryType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.LinkingType.html" title="wasmparser::LinkingType enum">LinkingType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Name.html" title="wasmparser::Name enum">Name</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.NameEntry.html" title="wasmparser::NameEntry enum">NameEntry</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.NameType.html" title="wasmparser::NameType enum">NameType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Operator.html" title="wasmparser::Operator enum">Operator</a></div><div class="item-right docblock-short"><p>Instructions as defined <a href="https://webassembly.github.io/spec/core/binary/instructions.html">here</a>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ParserInput.html" title="wasmparser::ParserInput enum">ParserInput</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.ParserState.html" title="wasmparser::ParserState enum">ParserState</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.RelocType.html" title="wasmparser::RelocType enum">RelocType</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.SectionCode.html" title="wasmparser::SectionCode enum">SectionCode</a></div><div class="item-right docblock-short"><p>Section code as defined <a href="https://webassembly.github.io/spec/core/binary/modules.html#sections">here</a>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.SectionContent.html" title="wasmparser::SectionContent enum">SectionContent</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.Type.html" title="wasmparser::Type enum">Type</a></div><div class="item-right docblock-short"><p>Types as defined <a href="https://webassembly.github.io/spec/core/syntax/types.html#types">here</a>.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="enum" href="enum.TypeOrFuncType.html" title="wasmparser::TypeOrFuncType enum">TypeOrFuncType</a></div><div class="item-right docblock-short"><p>Either a value type or a function type.</p>
</div></div></div><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.SectionReader.html" title="wasmparser::SectionReader trait">SectionReader</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.SectionWithLimitedItems.html" title="wasmparser::SectionWithLimitedItems trait">SectionWithLimitedItems</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmDecoder.html" title="wasmparser::WasmDecoder trait">WasmDecoder</a></div><div class="item-right docblock-short"></div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmFuncType.html" title="wasmparser::WasmFuncType trait">WasmFuncType</a></div><div class="item-right docblock-short"><p>Types that qualify as Wasm function types for validation purposes.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmGlobalType.html" title="wasmparser::WasmGlobalType trait">WasmGlobalType</a></div><div class="item-right docblock-short"><p>Types that qualify as Wasm global types for validation purposes.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmMemoryType.html" title="wasmparser::WasmMemoryType trait">WasmMemoryType</a></div><div class="item-right docblock-short"><p>Types that qualify as Wasm memory types for validation purposes.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmModuleResources.html" title="wasmparser::WasmModuleResources trait">WasmModuleResources</a></div><div class="item-right docblock-short"><p>Types  that qualify as Wasm valiation database.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmTableType.html" title="wasmparser::WasmTableType trait">WasmTableType</a></div><div class="item-right docblock-short"><p>Types that qualify as Wasm table types for validation purposes.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.WasmType.html" title="wasmparser::WasmType trait">WasmType</a></div><div class="item-right docblock-short"><p>Types that qualify as Wasm types for validation purposes.</p>
</div></div></div><h2 id="functions" class="small-section-header"><a href="#functions">Functions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.validate.html" title="wasmparser::validate fn">validate</a></div><div class="item-right docblock-short"><p>Test whether the given buffer contains a valid WebAssembly module,
analogous to WebAssembly.validate in the JS API.</p>
</div></div><div class="item-row"><div class="item-left module-item"><a class="fn" href="fn.validate_function_body.html" title="wasmparser::validate_function_body fn">validate_function_body</a></div><div class="item-right docblock-short"><p>Test whether the given buffer contains a valid WebAssembly function.
The resources parameter contains all needed data to validate the operators.</p>
</div></div></div><h2 id="types" class="small-section-header"><a href="#types">Type Definitions</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="type" href="type.Result.html" title="wasmparser::Result type">Result</a></div><div class="item-right docblock-short"></div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="wasmparser" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>